# all files / src/widgets/ TagMultiselectWidget.js

63.56% Statements 150/236
45.27% Branches 67/148
57.5% Functions 23/40
63.56% Lines 150/236

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445
    446
    447
    448
    449
    450
    451
    452
    453
    454
    455
    456
    457
    458
    459
    460
    461
    462
    463
    464
    465
    466
    467
    468
    469
    470
    471
    472
    473
    474
    475
    476
    477
    478
    479
    480
    481
    482
    483
    484
    485
    486
    487
    488
    489
    490
    491
    492
    493
    494
    495
    496
    497
    498
    499
    500
    501
    502
    503
    504
    505
    506
    507
    508
    509
    510
    511
    512
    513
    514
    515
    516
    517
    518
    519
    520
    521
    522
    523
    524
    525
    526
    527
    528
    529
    530
    531
    532
    533
    534
    535
    536
    537
    538
    539
    540
    541
    542
    543
    544
    545
    546
    547
    548
    549
    550
    551
    552
    553
    554
    555
    556
    557
    558
    559
    560
    561
    562
    563
    564
    565
    566
    567
    568
    569
    570
    571
    572
    573
    574
    575
    576
    577
    578
    579
    580
    581
    582
    583
    584
    585
    586
    587
    588
    589
    590
    591
    592
    593
    594
    595
    596
    597
    598
    599
    600
    601
    602
    603
    604
    605
    606
    607
    608
    609
    610
    611
    612
    613
    614
    615
    616
    617
    618
    619
    620
    621
    622
    623
    624
    625
    626
    627
    628
    629
    630
    631
    632
    633
    634
    635
    636
    637
    638
    639
    640
    641
    642
    643
    644
    645
    646
    647
    648
    649
    650
    651
    652
    653
    654
    655
    656
    657
    658
    659
    660
    661
    662
    663
    664
    665
    666
    667
    668
    669
    670
    671
    672
    673
    674
    675
    676
    677
    678
    679
    680
    681
    682
    683
    684
    685
    686
    687
    688
    689
    690
    691
    692
    693
    694
    695
    696
    697
    698
    699
    700
    701
    702
    703
    704
    705
    706
    707
    708
    709
    710
    711
    712
    713
    714
    715
    716
    717
    718
    719
    720
    721
    722
    723
    724
    725
    726
    727
    728
    729
    730
    731
    732
    733
    734
    735
    736
    737
    738
    739
    740
    741
    742
    743
    744
    745
    746
    747
    748
    749
    750
    751
    752
    753
    754
    755
    756
    757
    758
    759
    760
    761
    762
    763
    764
    765
    766
    767
    768
    769
    770
    771
    772
    773
    774
    775
    776
    777
    778
    779
    780
    781
    782
    783
    784
    785
    786
    787
    788
    789
    790
    791
    792
    793
    794
    795
    796
    797
    798
    799
    800
    801
    802
    803
    804
    805
    806
    807
    808
    809
    810

    1×
    24×

    24×

    24×

    24×
    24×
    24×
    24×
    24×
    24×

    24×

    24×

    24×
    24×
    24×
    24×
    24×
    24×
    24×
    24×

    24×

    24×

    24×

    24×

    24×

    24×

    24×
    21×

    21×

    21×

    21×

    21×

    21×

    1×
    1×

    20×

    20×

    3×

    24×

    24×
    2×

    24×
    24×
    21×

    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    66×
    66×
    58×

    66×

    1×

    24×

    24×

    24×

    1×

    1×

    1×

    1×

    1×
    58×

    1×
    63×

    3×

    60×
    29×

    31×

    43×

    22×

    9×

    1×
    23×

    1×

    1×
    5×

    11×

    10×

    1×
    18×

    18×
    18×
    45×
    38×

    7×

    1×
    54×

    54×
    48×
    48×
    48×
    48×

    6×

    1×

    1×
    48×

    48×

    1×
    3×

    3×

    3×
    2×
    1×

    1×

    1×

    1×
    3×

    3×

    3×
    2×
    1×

    1×

    1×

    1×
    79×
    79×
    78×

    78×

    1×

    1×
    67×
    67×
    20×
    20×

    1×
    66×
    81×

    1×
    66×

    66×
    2×

    2×

    2×

    1×
    3×

     /**
     * A basic tag multiselect widget, similar in concept to {@link OO.ui.ComboBoxInputWidget combo box widget}
     * that allows the user to add multiple values that are displayed in a tag area.
     *
     * This widget is a base widget; see {@link OO.ui.MenuTagMultiselectWidget MenuTagMultiselectWidget} and
     * {@link OO.ui.PopupTagMultiselectWidget PopupTagMultiselectWidget} for the implementations that use
     * a menu and a popup respectively.
     *
     *     @example
     *     // Example: A basic TagMultiselectWidget.
     *     var widget = new OO.ui.TagMultiselectWidget( {
     *         inputPosition: 'outline',
     *         allowedValues: [ 'Option 1', 'Option 2', 'Option 3' ],
     *         selected: [ 'Option 1' ]
     *     } );
     *     $( 'body' ).append( widget.$element );
     *
     * @class
     * @extends OO.ui.Widget
     * @mixins OO.ui.mixin.GroupWidget
     * @mixins OO.ui.mixin.DraggableGroupElement
     * @mixins OO.ui.mixin.IndicatorElement
     * @mixins OO.ui.mixin.IconElement
     * @mixins OO.ui.mixin.TabIndexedElement
     * @mixins OO.ui.mixin.FlaggedElement
     *
     * @constructor
     * @param {Object} config Configuration object
     * @cfg {Object} [input] Configuration options for the input widget
     * @cfg {OO.ui.InputWidget} [inputWidget] An optional input widget. If given, it will
     *  replace the input widget used in the TagMultiselectWidget. If not given,
     *  TagMultiselectWidget creates its own.
     * @cfg {boolean} [inputPosition='inline'] Position of the input. Options are:
     * 	- inline: The input is invisible, but exists inside the tag list, so
     * 		the user types into the tag groups to add tags.
     * 	- outline: The input is underneath the tag area.
     * 	- none: No input supplied
     * @cfg {boolean} [allowEditTags=true] Allow editing of the tags by clicking them
     * @cfg {boolean} [allowArbitrary=false] Allow data items to be added even if
     *  not present in the menu.
     * @cfg {Object[]} [allowedValues] An array representing the allowed items
     *  by their datas.
     * @cfg {boolean} [allowDuplicates=false] Allow duplicate items to be added
     * @cfg {boolean} [allowDisplayInvalidTags=false] Allow the display of
     *  invalid tags. These tags will display with an invalid state, and
     *  the widget as a whole will have an invalid state if any invalid tags
     *  are present.
     * @cfg {boolean} [allowReordering=true] Allow reordering of the items
     * @cfg {Object[]|String[]} [selected] A set of selected tags. If given,
     *  these will appear in the tag list on initialization, as long as they
     *  pass the validity tests.
     */
    OO.ui.TagMultiselectWidget = function OoUiTagMultiselectWidget( config ) {
    	var inputEvents,
    		rAF = window.requestAnimationFrame || setTimeout,
    		widget = this,
    		$tabFocus = $( '<span>' )
    			.addClass( 'oo-ui-tagMultiselectWidget-focusTrap' );

    	config = config || {};

    	// Parent constructor
    	OO.ui.TagMultiselectWidget.parent.call( this, config );

    	// Mixin constructors
    	OO.ui.mixin.GroupWidget.call( this, config );
    	OO.ui.mixin.IndicatorElement.call( this, config );
    	OO.ui.mixin.IconElement.call( this, config );
    	OO.ui.mixin.TabIndexedElement.call( this, config );
    	OO.ui.mixin.FlaggedElement.call( this, config );
    	OO.ui.mixin.DraggableGroupElement.call( this, config );

    	this.toggleDraggable(
    		config.allowReordering === undefined ?
    			true : !!config.allowReordering
    	);

    	this.inputPosition =
    		this.constructor.static.allowedInputPositions.indexOf( config.inputPosition ) > -1 ?
    			config.inputPosition : 'inline';
    	this.allowEditTags = config.allowEditTags === undefined ? true : !!config.allowEditTags;
    	this.allowArbitrary = !!config.allowArbitrary;
    	this.allowDuplicates = !!config.allowDuplicates;
    	this.allowedValues = config.allowedValues || [];
    	this.allowDisplayInvalidTags = config.allowDisplayInvalidTags;
    	this.hasInput = this.inputPosition !== 'none';
    	this.height = null;
    	this.valid = true;

    	this.$content = $( '<div>' )
    		.addClass( 'oo-ui-tagMultiselectWidget-content' );
    	this.$handle = $( '<div>' )
    		.addClass( 'oo-ui-tagMultiselectWidget-handle' )
    		.append(
    			this.$indicator,
    			this.$icon,
    			this.$content
    				.append(
    					this.$group
    						.addClass( 'oo-ui-tagMultiselectWidget-group' )
    				)
    		);

    	// Events
    	this.aggregate( {
    		remove: 'itemRemove',
    		navigate: 'itemNavigate',
    		select: 'itemSelect'
    	} );
    	this.connect( this, {
    		itemRemove: 'onTagRemove',
    		itemSelect: 'onTagSelect',
    		itemNavigate: 'onTagNavigate',
    		change: 'onChangeTags'
    	} );
    	this.$handle.on( {
    		mousedown: this.onMouseDown.bind( this )
    	} );

    	// Initialize
    	this.$element
    		.addClass( 'oo-ui-tagMultiselectWidget' )
    		.append( this.$handle );

    	if ( this.hasInput ) {
    		Iif ( config.inputWidget ) {
    			this.input = config.inputWidget;
    		} else {
    			this.input = new OO.ui.TextInputWidget( $.extend( {
    				placeholder: config.placeholder,
    				classes: [ 'oo-ui-tagMultiselectWidget-input' ]
    			}, config.input ) );
    		}
    		this.input.setDisabled( this.isDisabled() );

    		inputEvents = {
    			focus: this.onInputFocus.bind( this ),
    			blur: this.onInputBlur.bind( this ),
    			'propertychange change click mouseup keydown keyup input cut paste select focus':
    				OO.ui.debounce( this.updateInputSize.bind( this ) ),
    			keydown: this.onInputKeyDown.bind( this ),
    			keypress: this.onInputKeyPress.bind( this )
    		};

    		this.input.$input.on( inputEvents );

    		if ( this.inputPosition === 'outline' ) {
    			// Override max-height for the input widget
    			// in the case the widget is outline so it can
    			// stretch all the way if the widet is wide
    			this.input.$element.css( 'max-width', 'inherit' );
    			this.$element
    				.addClass( 'oo-ui-tagMultiselectWidget-outlined' )
    				.append( this.input.$element );
    		} else {
    			this.$element.addClass( 'oo-ui-tagMultiselectWidget-inlined' );
    			// HACK: When the widget is using 'inline' input, the
    			// behavior needs to only use the $input itself
    			// so we style and size it accordingly (otherwise
    			// the styling and sizing can get very convoluted
    			// when the wrapping divs and other elements)
    			// We are taking advantage of still being able to
    			// call the widget itself for operations like
    			// .getValue() and setDisabled() and .focus() but
    			// having only the $input attached to the DOM
    			this.$content.append( this.input.$input );
    		}
    	} else {
    		this.$content.append( $tabFocus );
    	}

    	this.setTabIndexedElement(
    		this.hasInput ?
    			this.input.$input :
    			$tabFocus
    	);

    	if ( config.selected ) {
    		this.setValue( config.selected );
    	}

    	// HACK: Input size needs to be calculated after everything
    	// else is rendered
    	rAF( function () {
    		if ( widget.hasInput ) {
    			widget.updateInputSize();
    		}
    	} );
    };

    /* Initialization */

    OO.inheritClass( OO.ui.TagMultiselectWidget, OO.ui.Widget );
    OO.mixinClass( OO.ui.TagMultiselectWidget, OO.ui.mixin.GroupWidget );
    OO.mixinClass( OO.ui.TagMultiselectWidget, OO.ui.mixin.DraggableGroupElement );
    OO.mixinClass( OO.ui.TagMultiselectWidget, OO.ui.mixin.IndicatorElement );
    OO.mixinClass( OO.ui.TagMultiselectWidget, OO.ui.mixin.IconElement );
    OO.mixinClass( OO.ui.TagMultiselectWidget, OO.ui.mixin.TabIndexedElement );
    OO.mixinClass( OO.ui.TagMultiselectWidget, OO.ui.mixin.FlaggedElement );

    /* Static properties */

    /**
     * Allowed input positions.
     * - inline: The input is inside the tag list
     * - outline: The input is under the tag list
     * - none: There is no input
     *
     * @property {Array}
     */
    OO.ui.TagMultiselectWidget.static.allowedInputPositions = [ 'inline', 'outline', 'none' ];

    /* Methods */

    /**
     * Handle mouse down events.
     *
     * @private
     * @param {jQuery.Event} e Mouse down event
     * @return {boolean} False to prevent defaults
     */
    OO.ui.TagMultiselectWidget.prototype.onMouseDown = function ( e ) {
    	if ( !this.isDisabled() && e.which === OO.ui.MouseButtons.LEFT ) {
    		this.focus();
    		return false;
    	}
    };

    /**
     * Handle key press events.
     *
     * @private
     * @param {jQuery.Event} e Key press event
     * @return {boolean} Whether to prevent defaults
     */
    OO.ui.TagMultiselectWidget.prototype.onInputKeyPress = function ( e ) {
    	var stopOrContinue,
    		withMetaKey = e.metaKey || e.ctrlKey;

    	if ( !this.isDisabled() ) {
    		if ( e.which === OO.ui.Keys.ENTER ) {
    			stopOrContinue = this.doInputEnter( e, withMetaKey );
    		}

    		// Make sure the input gets resized.
    		setTimeout( this.updateInputSize.bind( this ), 0 );
    		return stopOrContinue;
    	}
    };

    /**
     * Handle key down events.
     *
     * @private
     * @param {jQuery.Event} e Key down event
     * @return {boolean}
     */
    OO.ui.TagMultiselectWidget.prototype.onInputKeyDown = function ( e ) {
    	var movement, direction,
    		withMetaKey = e.metaKey || e.ctrlKey;

    	if ( !this.isDisabled() ) {
    		// 'keypress' event is not triggered for Backspace
    		if ( e.keyCode === OO.ui.Keys.BACKSPACE ) {
    			return this.doInputBackspace( e, withMetaKey );
    		} else if ( e.keyCode === OO.ui.Keys.ESCAPE ) {
    			return this.doInputEscape( e );
    		} else if (
    			e.keyCode === OO.ui.Keys.LEFT ||
    			e.keyCode === OO.ui.Keys.RIGHT
    		) {
    			if ( OO.ui.Element.static.getDir( this.$element ) === 'rtl' ) {
    				movement = {
    					left: 'forwards',
    					right: 'backwards'
    				};
    			} else {
    				movement = {
    					left: 'backwards',
    					right: 'forwards'
    				};
    			}
    			direction = e.keyCode === OO.ui.Keys.LEFT ?
    				movement.left : movement.right;

    			return this.doInputArrow( e, direction, withMetaKey );
    		}
    	}
    };

    /**
     * Respond to input focus event
     */
    OO.ui.TagMultiselectWidget.prototype.onInputFocus = function () {
    	this.$element.addClass( 'oo-ui-tagMultiselectWidget-focus' );
    };

    /**
     * Respond to input blur event
     */
    OO.ui.TagMultiselectWidget.prototype.onInputBlur = function () {
    	this.$element.removeClass( 'oo-ui-tagMultiselectWidget-focus' );
    };

    /**
     * Perform an action after the enter key on the input
     *
     * @param {jQuery.Event} e Event data
     * @param {boolean} [withMetaKey] Whether this key was pressed with
     * a meta key like 'ctrl'
     * @return {boolean} Whether to prevent defaults
     */
    OO.ui.TagMultiselectWidget.prototype.doInputEnter = function () {
    	this.addTagFromInput();
    	return false;
    };

    /**
     * Perform an action responding to the enter key on the input
     *
     * @param {jQuery.Event} e Event data
     * @param {boolean} [withMetaKey] Whether this key was pressed with
     * a meta key like 'ctrl'
     * @return {boolean} Whether to prevent defaults
     */
    OO.ui.TagMultiselectWidget.prototype.doInputBackspace = function ( e, withMetaKey ) {
    	var items, item;

    	if (
    		this.inputPosition === 'inline' &&
    		this.input.getValue() === '' &&
    		!this.isEmpty()
    	) {
    		// Delete the last item
    		items = this.getItems();
    		item = items[ items.length - 1 ];
    		this.removeItems( [ item ] );
    		// If Ctrl/Cmd was pressed, delete item entirely.
    		// Otherwise put it into the text field for editing.
    		if ( !withMetaKey ) {
    			this.input.setValue( item.getData() );
    		}

    		return false;
    	}
    };

    /**
     * Perform an action after the escape key on the input
     *
     * @param {jQuery.Event} e Event data
     */
    OO.ui.TagMultiselectWidget.prototype.doInputEscape = function () {
    	this.clearInput();
    };

    /**
     * Perform an action after the arrow key on the input, select the previous
     * or next item from the input.
     * See #getPreviousItem and #getNextItem
     *
     * @param {jQuery.Event} e Event data
     * @param {string} direction Direction of the movement; forwards or backwards
     * @param {boolean} [withMetaKey] Whether this key was pressed with
     *  a meta key like 'ctrl'
     */
    OO.ui.TagMultiselectWidget.prototype.doInputArrow = function ( e, direction ) {
    	if (
    		this.inputPosition === 'inline' &&
    		!this.isEmpty()
    	) {
    		if ( direction === 'backwards' ) {
    			// Get previous item
    			this.getPreviousItem().focus();
    		} else {
    			// Get next item
    			this.getNextItem().focus();
    		}
    	}
    };

    /**
     * Respond to item select event
     *
     * @param {OO.ui.TagItemWidget} item Selected item
     */
    OO.ui.TagMultiselectWidget.prototype.onTagSelect = function ( item ) {
    	if ( this.hasInput && this.allowEditTags ) {
    		if ( this.input.getValue() ) {
    			this.addTagFromInput();
    		}
    		// 1. Get the label of the tag into the input
    		this.input.setValue( item.getData() );
    		// 2. Remove the tag
    		this.removeItems( [ item ] );
    		// 3. Focus the input
    		this.focus();
    	}
    };

    /**
     * Respond to change event, where items were added, removed, or cleared.
     */
    OO.ui.TagMultiselectWidget.prototype.onChangeTags = function () {
    	this.toggleValid( this.checkValidity() );
    	if ( this.hasInput ) {
    		this.updateInputSize();
    	}
    	this.updateIfHeightChanged();
    };

    /**
     * @inheritdoc
     */
    OO.ui.TagMultiselectWidget.prototype.setDisabled = function ( isDisabled ) {
    	// Parent method
    	OO.ui.TagMultiselectWidget.parent.prototype.setDisabled.call( this, isDisabled );

    	Iif ( this.hasInput && this.input ) {
    		this.input.setDisabled( !!isDisabled );
    	}

    	Iif ( this.items ) {
    		this.getItems().forEach( function ( item ) {
    			item.setDisabled( !!isDisabled );
    		} );
    	}
    };

    /**
     * Respond to tag remove event
     * @param {OO.ui.TagItemWidget} item Removed tag
     */
    OO.ui.TagMultiselectWidget.prototype.onTagRemove = function ( item ) {
    	this.removeTagByData( item.getData() );
    };

    /**
     * Respond to navigate event on the tag
     *
     * @param {OO.ui.TagItemWidget} item Removed tag
     * @param {string} direction Direction of movement; 'forwards' or 'backwards'
     */
    OO.ui.TagMultiselectWidget.prototype.onTagNavigate = function ( item, direction ) {
    	if ( direction === 'forwards' ) {
    		this.getNextItem( item ).focus();
    	} else {
    		this.getPreviousItem( item ).focus();
    	}
    };

    /**
     * Add tag from input value
     */
    OO.ui.TagMultiselectWidget.prototype.addTagFromInput = function () {
    	var val = this.input.getValue(),
    		isValid = this.isAllowedData( val );

    	if ( !val ) {
    		return;
    	}

    	if ( isValid || this.allowDisplayInvalidTags ) {
    		this.addTag( val );
    		this.clearInput();
    		this.focus();
    	}
    };

    /**
     * Clear the input
     */
    OO.ui.TagMultiselectWidget.prototype.clearInput = function () {
    	this.input.setValue( '' );
    };

    /**
     * Check whether the given value is a duplicate of an existing
     * tag already in the list.
     *
     * @param {string|Object} data Requested value
     * @return {boolean} Value is duplicate
     */
    OO.ui.TagMultiselectWidget.prototype.isDuplicateData = function ( data ) {
    	return !!this.findItemFromData( data );
    };

    /**
     * Check whether a given value is allowed to be added
     *
     * @param {string|Object} data Requested value
     * @return {boolean} Value is allowed
     */
    OO.ui.TagMultiselectWidget.prototype.isAllowedData = function ( data ) {
    	if (
    		!this.allowDuplicates &&
    		this.isDuplicateData( data )
    	) {
    		return false;
    	}

    	if ( this.allowArbitrary ) {
    		return true;
    	}

    	// Check with allowed values
    	if (
    		this.getAllowedValues().some( function ( value ) {
    			return data === value;
    		} )
    	) {
    		return true;
    	}

    	return false;
    };

    /**
     * Get the allowed values list
     *
     * @return {string[]} Allowed data values
     */
    OO.ui.TagMultiselectWidget.prototype.getAllowedValues = function () {
    	return this.allowedValues;
    };

    /**
     * Add a value to the allowed values list
     *
     * @param {string} value Allowed data value
     */
    OO.ui.TagMultiselectWidget.prototype.addAllowedValue = function ( value ) {
    	if ( this.allowedValues.indexOf( value ) === -1 ) {
    		this.allowedValues.push( value );
    	}
    };

    /**
     * Get the datas of the currently selected items
     *
     * @return {string[]|Object[]} Datas of currently selected items
     */
    OO.ui.TagMultiselectWidget.prototype.getValue = function () {
    	return this.getItems()
    		.filter( function ( item ) {
    			return item.isValid();
    		} )
    		.map( function ( item ) {
    			return item.getData();
    		} );
    };

    /**
     * Set the value of this widget by datas.
     *
     * @param {string|string[]|Object|Object[]} valueObject An object representing the data
     *  and label of the value. If the widget allows arbitrary values,
     *  the items will be added as-is. Otherwise, the data value will
     *  be checked against allowedValues.
     *  This object must contain at least a data key. Example:
     *  { data: 'foo', label: 'Foo item' }
     *  For multiple items, use an array of objects. For example:
     *   [
     *      { data: 'foo', label: 'Foo item' },
     *      { data: 'bar', label: 'Bar item' }
     * 	 ]
     *  Value can also be added with plaintext array, for example:
     *  [ 'foo', 'bar', 'bla' ] or a single string, like 'foo'
     */
    OO.ui.TagMultiselectWidget.prototype.setValue = function ( valueObject ) {
    	valueObject = Array.isArray( valueObject ) ? valueObject : [ valueObject ];

    	this.clearItems();
    	valueObject.forEach( function ( obj ) {
    		if ( typeof obj === 'string' ) {
    			this.addTag( obj );
    		} else {
    			this.addTag( obj.data, obj.label );
    		}
    	}.bind( this ) );
    };

    /**
     * Add tag to the display area
     *
     * @param {string|Object} data Tag data
     * @param {string} [label] Tag label. If no label is provided, the
     *  stringified version of the data will be used instead.
     * @return {boolean} Item was added successfully
     */
    OO.ui.TagMultiselectWidget.prototype.addTag = function ( data, label ) {
    	var newItemWidget,
    		isValid = this.isAllowedData( data );

    	if ( isValid || this.allowDisplayInvalidTags ) {
    		newItemWidget = this.createTagItemWidget( data, label );
    		newItemWidget.toggleValid( isValid );
    		this.addItems( [ newItemWidget ] );
    		return true;
    	}
    	return false;
    };

    /**
     * Remove tag by its data property.
     *
     * @param {string|Object} data Tag data
     */
    OO.ui.TagMultiselectWidget.prototype.removeTagByData = function ( data ) {
    	var item = this.findItemFromData( data );

    	this.removeItems( [ item ] );
    };

    /**
     * Construct a OO.ui.TagItemWidget (or a subclass thereof) from given label and data.
     *
     * @protected
     * @param {string} data Item data
     * @param {string} label The label text.
     * @return {OO.ui.TagItemWidget}
     */
    OO.ui.TagMultiselectWidget.prototype.createTagItemWidget = function ( data, label ) {
    	label = label || data;

    	return new OO.ui.TagItemWidget( { data: data, label: label } );
    };

    /**
     * Given an item, returns the item after it. If the item is already the
     * last item, return `this.input`. If no item is passed, returns the
     * very first item.
     *
     * @protected
     * @param {OO.ui.TagItemWidget} [item] Tag item
     * @return {OO.ui.Widget} The next widget available.
     */
    OO.ui.TagMultiselectWidget.prototype.getNextItem = function ( item ) {
    	var itemIndex = this.items.indexOf( item );

    	Iif ( item === undefined || itemIndex === -1 ) {
    		return this.items[ 0 ];
    	}

    	if ( itemIndex === this.items.length - 1 ) { // Last item
    		if ( this.hasInput ) {
    			return this.input;
    		} else {
    			// Return first item
    			return this.items[ 0 ];
    		}
    	} else {
    		return this.items[ itemIndex + 1 ];
    	}
    };

    /**
     * Given an item, returns the item before it. If the item is already the
     * first item, return `this.input`. If no item is passed, returns the
     * very last item.
     *
     * @protected
     * @param {OO.ui.TagItemWidget} [item] Tag item
     * @return {OO.ui.Widget} The previous widget available.
     */
    OO.ui.TagMultiselectWidget.prototype.getPreviousItem = function ( item ) {
    	var itemIndex = this.items.indexOf( item );

    	Iif ( item === undefined || itemIndex === -1 ) {
    		return this.items[ this.items.length - 1 ];
    	}

    	if ( itemIndex === 0 ) {
    		if ( this.hasInput ) {
    			return this.input;
    		} else {
    			// Return the last item
    			return this.items[ this.items.length - 1 ];
    		}
    	} else {
    		return this.items[ itemIndex - 1 ];
    	}
    };

    /**
     * Update the dimensions of the text input field to encompass all available area.
     * This is especially relevant for when the input is at the edge of a line
     * and should get smaller. The usual operation (as an inline-block with min-width)
     * does not work in that case, pushing the input downwards to the next line.
     *
     * @private
     */
    OO.ui.TagMultiselectWidget.prototype.updateInputSize = function () {
    	var $lastItem, direction, contentWidth, currentWidth, bestWidth;
    	if ( this.inputPosition === 'inline' && !this.isDisabled() ) {
    		Eif ( this.input.$input[ 0 ].scrollWidth === 0 ) {
    			// Input appears to be attached but not visible.
    			// Don't attempt to adjust its size, because our measurements
    			// are going to fail anyway.
    			return;
    		}
    		this.input.$input.css( 'width', '1em' );
    		$lastItem = this.$group.children().last();
    		direction = OO.ui.Element.static.getDir( this.$handle );

    		// Get the width of the input with the placeholder text as
    		// the value and save it so that we don't keep recalculating
    		if (
    			this.contentWidthWithPlaceholder === undefined &&
    			this.input.getValue() === '' &&
    			this.input.$input.attr( 'placeholder' ) !== undefined
    		) {
    			this.input.setValue( this.input.$input.attr( 'placeholder' ) );
    			this.contentWidthWithPlaceholder = this.input.$input[ 0 ].scrollWidth;
    			this.input.setValue( '' );

    		}

    		// Always keep the input wide enough for the placeholder text
    		contentWidth = Math.max(
    			this.input.$input[ 0 ].scrollWidth,
    			// undefined arguments in Math.max lead to NaN
    			( this.contentWidthWithPlaceholder === undefined ) ?
    				0 : this.contentWidthWithPlaceholder
    		);
    		currentWidth = this.input.$input.width();

    		if ( contentWidth < currentWidth ) {
    			this.updateIfHeightChanged();
    			// All is fine, don't perform expensive calculations
    			return;
    		}

    		if ( $lastItem.length === 0 ) {
    			bestWidth = this.$content.innerWidth();
    		} else {
    			bestWidth = direction === 'ltr' ?
    				this.$content.innerWidth() - $lastItem.position().left - $lastItem.outerWidth() :
    				$lastItem.position().left;
    		}

    		// Some safety margin for sanity, because I *really* don't feel like finding out where the few
    		// pixels this is off by are coming from.
    		bestWidth -= 10;
    		if ( contentWidth > bestWidth ) {
    			// This will result in the input getting shifted to the next line
    			bestWidth = this.$content.innerWidth() - 10;
    		}
    		this.input.$input.width( Math.floor( bestWidth ) );
    		this.updateIfHeightChanged();
    	} else {
    		this.updateIfHeightChanged();
    	}
    };

    /**
     * Determine if widget height changed, and if so,
     * emit the resize event. This is useful for when there are either
     * menus or popups attached to the bottom of the widget, to allow
     * them to change their positioning in case the widget moved down
     * or up.
     *
     * @private
     */
    OO.ui.TagMultiselectWidget.prototype.updateIfHeightChanged = function () {
    	var height = this.$element.height();
    	if ( height !== this.height ) {
    		this.height = height;
    		this.emit( 'resize' );
    	}
    };

    /**
     * Check whether all items in the widget are valid
     *
     * @return {boolean} Widget is valid
     */
    OO.ui.TagMultiselectWidget.prototype.checkValidity = function () {
    	return this.getItems().every( function ( item ) {
    		return item.isValid();
    	} );
    };

    /**
     * Set the valid state of this item
     *
     * @param {boolean} [valid] Item is valid
     * @fires valid
     */
    OO.ui.TagMultiselectWidget.prototype.toggleValid = function ( valid ) {
    	valid = valid === undefined ? !this.valid : !!valid;

    	if ( this.valid !== valid ) {
    		this.valid = valid;

    		this.setFlags( { invalid: !this.valid } );

    		this.emit( 'valid', this.valid );
    	}
    };

    /**
     * Get the current valid state of the widget
     *
     * @return {boolean} Widget is valid
     */
    OO.ui.TagMultiselectWidget.prototype.isValid = function () {
    	return this.valid;
    };